modules:
begin
  module Memo: PARENT
  module Core: IMPORT
  module Process: IMPORT
  module System: IMPORT
  module Reset: IMPORT
  module Ioport: IMPORT
  module Random: IMPORT
end

import:
begin
  register LED: L[8]
  object rnd: Random.random
  signal SW: L[4]
end

temp:
begin
  register TEMP_0: L[28]
end

data:
begin
  register d: L[8]
  register speed: I[4]
  register LOOP_j_2: I[5]
  register LOOP_j_3: I[5]
  array collect: register[4] of L[4]
  register sample: L[4]
  register TEMP_0: L[28]
  register LOOP_i_0: I[4]
  register LOOP_i_1: I[4]
  register LOOP_i_4: I[4]
  register LOOP_i_5: I[4]
  register LOOP_i_6: I[4]
  array pattern: register[4] of L[4]
  register correct: B
  register pat: L[4]
end

types:
begin
  type Random.random: {
      method init ()
      method read (L[8]:LHS)
      method seed (L[8]:RHS)
    }
end

code:
begin
               i1_fun: 
                       fun rnd.init()
           i1_fun_end: 
                       nop
            i2_assign: 
                       move (speed,7) with ET=I[4]
        i2_assign_end: 
                       jump (i4_for_loop)
              i3_loop: 
                       nop
          i4_for_loop: 
                       move (LOOP_i_0,0) with ET=I[4]
     i4_for_loop_cond: 
                       bind (2)
                       expr ($immed.[1],3,>=,LOOP_i_0) with ET=I[4]
                       falsejump ($immed.[1],i13_for_loop)
               i5_fun: 
                       fun rnd.read(d)
           i5_fun_end: 
                       nop
            i6_branch: 
                       bind (2)
                       expr ($immed.[1],d,<,64) with ET=L[8]
                       falsejump ($immed.[1],i8_branch)
            i7_assign: 
                       move (pattern.[LOOP_i_0:CT=L[4]],0) with ET=L[4]
        i7_assign_end: 
                       jump (i4_for_loop_incr)
            i8_branch: 
                       bind (2)
                       expr ($immed.[1],d,<,128) with ET=L[8]
                       falsejump ($immed.[1],i10_branch)
            i9_assign: 
                       move (pattern.[LOOP_i_0:CT=L[4]],1) with ET=L[4]
        i9_assign_end: 
                       jump (i4_for_loop_incr)
           i10_branch: 
                       bind (2)
                       expr ($immed.[1],d,<,192) with ET=L[8]
                       falsejump ($immed.[1],i12_assign)
           i11_assign: 
                       move (pattern.[LOOP_i_0:CT=L[4]],2) with ET=L[4]
       i11_assign_end: 
                       jump (i4_for_loop_incr)
           i12_assign: 
                       move (pattern.[LOOP_i_0:CT=L[4]],3) with ET=L[4]
       i12_assign_end: 
                       nop
       i10_branch_end: 
                       nop
        i8_branch_end: 
                       nop
        i6_branch_end: 
                       nop
     i4_for_loop_incr: 
                       bind (3)
                       expr (LOOP_i_0,LOOP_i_0,+,1) with ET=I[4]
                       nop
                       jump (i4_for_loop_cond)
      i4_for_loop_end: 
                       nop
         i13_for_loop: 
                       move (LOOP_i_1,0) with ET=I[4]
    i13_for_loop_cond: 
                       bind (2)
                       expr ($immed.[1],3,>=,LOOP_i_1) with ET=I[4]
                       falsejump ($immed.[1],i22_assign)
           i14_assign: 
                       move (LED,0) with ET=L[8]
       i14_assign_end: 
                       nop
         i15_for_loop: 
                       move (LOOP_j_2,0) with ET=I[5]
    i15_for_loop_cond: 
                       bind (2)
                       expr ($immed.[1],speed,>=,LOOP_j_2) with ET=I[5]
                       falsejump ($immed.[1],i17_assign)
            i16_delay: 
                       move ($tmp.[delay_count],4999998) with ET=L[25]
       i16_delay_loop: 
                       bind (4)
                       expr ($tmp.[delay_count],$tmp.[delay_count],-,1) with ET=L[25]
                       nop
                       expr ($immed.[1],$tmp.[delay_count],=,0) with ET=L[25]
                       falsejump ($immed.[1],i16_delay_loop)
   i16_delay_loop_end: 
                       jump (i15_for_loop_incr)
        i16_delay_end: 
                       nop
    i15_for_loop_incr: 
                       bind (3)
                       expr (LOOP_j_2,LOOP_j_2,+,1) with ET=I[5]
                       nop
                       jump (i15_for_loop_cond)
     i15_for_loop_end: 
                       nop
           i17_assign: 
                       move (pat,pattern.[LOOP_i_1:CT=L[4]]) with ET=L[4]
       i17_assign_end: 
                       nop
           i18_assign: 
                       expr (pat,pat,lsl,1) with ET=L[4]
                       nop
       i18_assign_end: 
                       nop
           i19_assign: 
                       expr (LED,11,lsl,pat) with ET=L[8]
                       nop
       i19_assign_end: 
                       nop
         i20_for_loop: 
                       move (LOOP_j_3,0) with ET=I[5]
    i20_for_loop_cond: 
                       bind (2)
                       expr ($immed.[1],speed,>=,LOOP_j_3) with ET=I[5]
                       falsejump ($immed.[1],i13_for_loop_incr)
            i21_delay: 
                       move ($tmp.[delay_count],4999998) with ET=L[25]
       i21_delay_loop: 
                       bind (4)
                       expr ($tmp.[delay_count],$tmp.[delay_count],-,1) with ET=L[25]
                       nop
                       expr ($immed.[1],$tmp.[delay_count],=,0) with ET=L[25]
                       falsejump ($immed.[1],i21_delay_loop)
   i21_delay_loop_end: 
                       jump (i20_for_loop_incr)
        i21_delay_end: 
                       nop
    i20_for_loop_incr: 
                       bind (3)
                       expr (LOOP_j_3,LOOP_j_3,+,1) with ET=I[5]
                       nop
                       jump (i20_for_loop_cond)
     i20_for_loop_end: 
                       nop
    i13_for_loop_incr: 
                       bind (3)
                       expr (LOOP_i_1,LOOP_i_1,+,1) with ET=I[4]
                       nop
                       jump (i13_for_loop_cond)
     i13_for_loop_end: 
                       nop
           i22_assign: 
                       move (LED,0) with ET=L[8]
       i22_assign_end: 
                       nop
         i23_for_loop: 
                       move (LOOP_i_4,0) with ET=I[4]
    i23_for_loop_cond: 
                       bind (2)
                       expr ($immed.[1],3,>=,LOOP_i_4) with ET=I[4]
                       falsejump ($immed.[1],i41_assign)
          i24_waitfor: 
                       bind (2)
                       expr ($immed.[1],SW,<>,1111) with ET=L[4]
                       falsejump ($immed.[1],i24_waitfor)
      i24_waitfor_end: 
                       nop
           i25_assign: 
                       move (sample,SW) with ET=L[4]
       i25_assign_end: 
                       nop
           i26_select: 
                       bind (18)
           i26_case_1: 
                       expr ($immed.[1],sample,=,1110) with ET=L[4]
                       falsejump ($immed.[1],i26_case_2)
                       jump (i27_assign)
           i26_case_2: 
                       expr ($immed.[1],sample,=,1101) with ET=L[4]
                       falsejump ($immed.[1],i26_case_3)
                       jump (i29_assign)
           i26_case_3: 
                       expr ($immed.[1],sample,=,1011) with ET=L[4]
                       falsejump ($immed.[1],i26_case_4)
                       jump (i31_assign)
           i26_case_4: 
                       expr ($immed.[1],sample,=,0111) with ET=L[4]
                       falsejump ($immed.[1],i26_case_5)
                       jump (i33_assign)
           i26_case_5: 
                       jump (i35_assign)
           i27_assign: 
                       move (collect.[LOOP_i_4:CT=L[4]],0) with ET=L[4]
       i27_assign_end: 
                       nop
           i28_assign: 
                       move (LED,11) with ET=L[8]
       i28_assign_end: 
                       jump (i37_delay)
           i29_assign: 
                       move (collect.[LOOP_i_4:CT=L[4]],1) with ET=L[4]
       i29_assign_end: 
                       nop
           i30_assign: 
                       move (LED,1100) with ET=L[8]
       i30_assign_end: 
                       jump (i37_delay)
           i31_assign: 
                       move (collect.[LOOP_i_4:CT=L[4]],2) with ET=L[4]
       i31_assign_end: 
                       nop
           i32_assign: 
                       move (LED,110000) with ET=L[8]
       i32_assign_end: 
                       jump (i37_delay)
           i33_assign: 
                       move (collect.[LOOP_i_4:CT=L[4]],3) with ET=L[4]
       i33_assign_end: 
                       nop
           i34_assign: 
                       move (LED,11000000) with ET=L[8]
       i34_assign_end: 
                       jump (i37_delay)
           i35_assign: 
                       expr (LOOP_i_4,LOOP_i_4,+,1) with ET=I[4]
                       nop
       i35_assign_end: 
                       nop
           i36_assign: 
                       move (LED,10101010) with ET=L[8]
       i36_assign_end: 
                       nop
       i26_select_end: 
                       nop
            i37_delay: 
                       move ($tmp.[delay_count],9999998) with ET=L[26]
       i37_delay_loop: 
                       bind (4)
                       expr ($tmp.[delay_count],$tmp.[delay_count],-,1) with ET=L[26]
                       nop
                       expr ($immed.[1],$tmp.[delay_count],=,0) with ET=L[26]
                       falsejump ($immed.[1],i37_delay_loop)
   i37_delay_loop_end: 
                       jump (i38_waitfor)
        i37_delay_end: 
                       nop
          i38_waitfor: 
                       bind (2)
                       expr ($immed.[1],SW,=,1111) with ET=L[4]
                       falsejump ($immed.[1],i38_waitfor)
      i38_waitfor_end: 
                       nop
           i39_assign: 
                       move (LED,0) with ET=L[8]
       i39_assign_end: 
                       nop
            i40_delay: 
                       move ($tmp.[delay_count],9999998) with ET=L[26]
       i40_delay_loop: 
                       bind (4)
                       expr ($tmp.[delay_count],$tmp.[delay_count],-,1) with ET=L[26]
                       nop
                       expr ($immed.[1],$tmp.[delay_count],=,0) with ET=L[26]
                       falsejump ($immed.[1],i40_delay_loop)
   i40_delay_loop_end: 
                       jump (i23_for_loop_incr)
        i40_delay_end: 
                       nop
    i23_for_loop_incr: 
                       bind (3)
                       expr (LOOP_i_4,LOOP_i_4,+,1) with ET=I[4]
                       nop
                       jump (i23_for_loop_cond)
     i23_for_loop_end: 
                       nop
           i41_assign: 
                       move (correct,true) with ET=B
       i41_assign_end: 
                       nop
         i42_for_loop: 
                       move (LOOP_i_5,0) with ET=I[4]
    i42_for_loop_cond: 
                       bind (2)
                       expr ($immed.[1],3,>=,LOOP_i_5) with ET=I[4]
                       falsejump ($immed.[1],i45_branch)
           i43_branch: 
                       bind (2)
                       expr ($immed.[1],collect.[LOOP_i_5:CT=L[4]],<>,pattern.[LOOP_i_5:CT=L[4]]) with ET=L[4]
                       falsejump ($immed.[1],i42_for_loop_incr)
           i44_assign: 
                       move (correct,false) with ET=B
       i44_assign_end: 
                       nop
       i43_branch_end: 
                       nop
    i42_for_loop_incr: 
                       bind (3)
                       expr (LOOP_i_5,LOOP_i_5,+,1) with ET=I[4]
                       nop
                       jump (i42_for_loop_cond)
     i42_for_loop_end: 
                       nop
           i45_branch: 
                       bind (2)
                       expr ($immed.[1],correct,=,true) with ET=B
                       falsejump ($immed.[1],i51_assign)
         i46_for_loop: 
                       move (LOOP_i_6,1) with ET=I[4]
    i46_for_loop_cond: 
                       bind (2)
                       expr ($immed.[1],3,>=,LOOP_i_6) with ET=I[4]
                       falsejump ($immed.[1],i51_assign)
           i47_assign: 
                       move (LED,11111111) with ET=L[8]
       i47_assign_end: 
                       nop
            i48_delay: 
                       move ($tmp.[delay_count],49999998) with ET=L[28]
       i48_delay_loop: 
                       bind (4)
                       expr ($tmp.[delay_count],$tmp.[delay_count],-,1) with ET=L[28]
                       nop
                       expr ($immed.[1],$tmp.[delay_count],=,0) with ET=L[28]
                       falsejump ($immed.[1],i48_delay_loop)
   i48_delay_loop_end: 
                       jump (i49_assign)
        i48_delay_end: 
                       nop
           i49_assign: 
                       move (LED,00000000) with ET=L[8]
       i49_assign_end: 
                       nop
            i50_delay: 
                       move ($tmp.[delay_count],49999998) with ET=L[28]
       i50_delay_loop: 
                       bind (4)
                       expr ($tmp.[delay_count],$tmp.[delay_count],-,1) with ET=L[28]
                       nop
                       expr ($immed.[1],$tmp.[delay_count],=,0) with ET=L[28]
                       falsejump ($immed.[1],i50_delay_loop)
   i50_delay_loop_end: 
                       jump (i46_for_loop_incr)
        i50_delay_end: 
                       nop
    i46_for_loop_incr: 
                       bind (3)
                       expr (LOOP_i_6,LOOP_i_6,+,1) with ET=I[4]
                       nop
                       jump (i46_for_loop_cond)
     i46_for_loop_end: 
                       nop
       i45_branch_end: 
                       nop
           i51_assign: 
                       expr (speed,speed,-,1) with ET=I[4]
                       nop
       i51_assign_end: 
                       nop
           i52_branch: 
                       bind (2)
                       expr ($immed.[1],speed,=,0) with ET=I[4]
                       falsejump ($immed.[1],i4_for_loop)
           i53_assign: 
                       move (speed,7) with ET=I[4]
       i53_assign_end: 
                       nop
       i52_branch_end: 
                       jump (i4_for_loop)
          i3_loop_end: 
end
